--[[Copyright (c) 2012-2020 baby-bus.com

http://www.baby-bus.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]
----------------------
-- 类
----------------------
local M    = class("ProgressBar", require("app.common.node.ProgressBar"))
M.TAG    = "ProgressBar"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..
----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
    -- [超类调用]
    M.super.ctor(self, params)
    self._step = 1
end

-- 显示星星
function M:showStar(percent)
    if percent * 100 >= self._starPercent[3] and self._starNum == 2 then
        self:showAction(self._star[3])
        self._starNum = 3
    elseif percent * 100 >= self._starPercent[2] and self._starNum == 1 then
        self:showAction(self._star[2])
        self._starNum = 2
        self._main:startStep3()
    elseif percent * 100 >= self._starPercent[1] and self._starNum == 0 then
        self:showAction(self._star[1])
        self._starNum = 1
        self._main:startStep2()
    end
end

-- 更新进度条
function M:updateProgressbar(percent)
    if not percent then return end
    -- self:moveUpParticle(percent)
    if self._starNum > 0 and self._starPercent[self._starNum] > percent * 100 then
        self:hideAction(self._star[self._starNum])
    end
    self._inner:line({
        { "progressto", 0.3, percent * 100 },
        { "fn", handlerP(self, self.showStar, percent) },
        { "fn", handlerP(self, self.updateStep, percent) },
        { "fn", function()
            self._percent = percent
        end },
    })
end

--更新阶段
function M:updateStep(percent)
    if percent * 100 >= 12 and self._step == 1 then
        self._step = 2
        self._main:basketMove(1)
    end
end

return M