--[[
   Copyright (c) 2012-2021 baby-bus.com

   TODO:    地图
   Author:  Neighbour Mr.Wang
   Date:    2021.08.03
   
   http://www.baby-bus.com/
   
]]

----------------------
-- 类
----------------------
local M     = class("Map", require("app.common.nodebase.MapBase"))
M.TAG       = "Map"


----------------------
-- 公共参数
----------------------


----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
    -- [超类调用]
    M.super.ctor(self, params)
end


----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
    -- [超类调用]
    M.super.onRender(self)
end

-- 加载显示(overwrite)
function M:loadDisplay()
    -- 背景
    local bg = D.img("biathlon/bg.png"):to(self):anchor(cc.p(0, 0.1))
    -- 显示辅助编号
    -- local node = U.loadLabel({
    --     text        = self.rowTag..", "..self.colTag.."("..self._mapId..")z"..self:z(),              
    --     fontSize    = 64,            
    --     color       = ccc3(N.random(0,255), N.random(0,255), N.random(0,255)),
    -- }):p(self.mapSize.width / 2, self.mapSize.height / 2):to(bg)
end

-- 显示雪花粒子
function M:showSnowPar()
	-- 管理粒子
    if self._particle1 then
        self._particle1:resetSystem()
    end
    if self._particle2 then
        self._particle2:resetSystem()
    end
end

-- 隐藏雪花粒子
function M:hideSnowPar()
	-- 管理粒子
    if self._particle1 then
        self._particle1:stopSystem()
    end
    if self._particle2 then
        self._particle2:stopSystem()
    end
end


----------------------
-- 结点析构
----------------------
function M:onDestructor()
    -- [超类调用]
    M.super.onDestructor(self)
end

----------------------
-- 过度动画开始之前的调用
----------------------
--[[--

1.资源释放，退出场景前的操作准备
2.处理视图结点卸载、事件解除绑定等相关操作

]]
function M:onExitTransitionStart()

end

return M