--[[
   Copyright (c) 2012-2021 baby-bus.com

   TODO:    路障(在打靶的地方拦截玩家)
   Author:  Neighbour Mr.Wang
   Date:    2021.08.25
   
   http://www.baby-bus.com/
   
]]----------------------
-- 类
----------------------

local M     = classSprite("Roadblock")
M.TAG       = "Roadblock"

----------------------
-- 公共参数
----------------------

----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]

function M:ctor(params)
    -- [超类调用]
    M.super.ctor(self, params)

    self._allowNum = 0 --可通行的道路数
end

----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
    -- [超类调用]
    M.super.onRender(self)
    
    -- 图片渲染
    self:loadDisplay()
end

-- 图片渲染
function M:loadDisplay()
    self:display("biathlon/shoot/roadblock/bar1.png")

    -- 上方棒子
    local topBar = D.img("biathlon/shoot/roadblock/top1.png"):p(72, 130):to(self, -50)
    self._topBar = topBar
    -- 下方棒子
    local downBar = D.img("biathlon/shoot/roadblock/down1.png"):p(73, -10):to(self, 50)
    self._downBar = downBar
end

-- 允许通行
function M:allowPass(types)
	self:display("biathlon/shoot/roadblock/bar2.png")
    if types == 1 then
        self._topBar:display("biathlon/shoot/roadblock/top2.png"):p(72, 120)
    else
        self._downBar:display("biathlon/shoot/roadblock/down2.png")
    end

    self._allowNum = self._allowNum + 1
    if self._allowNum == 1 then
        self:plan(function()
            self:display("biathlon/shoot/roadblock/bar1.png")
        end, 1)
    else
        self:stop()
	    self:display("biathlon/shoot/roadblock/bar2.png")
    end
end

----------------------
-- 结点析构
----------------------

function M:onDestructor()
    -- [超类调用]
    M.super.onDestructor(self)
end

----------------------
-- 过度动画开始之前的调用
----------------------
--[[--

1.资源释放，退出场景前的操作准备
2.处理视图结点卸载、事件解除绑定等相关操作

]]

function M:onExitTransitionStart()

end

----------------------
-- 验证
----------------------

-- 验证合法性[构造函数参数]
function M:assertParameters(params)
    
end

return M
