--[[
   Copyright (c) 2012-2021 baby-bus.com

   TODO:    道具箱
   Author:  Neighbour Mr.Wang
   Date:    2021.08.06
   
   http://www.baby-bus.com/
   
]]

----------------------
-- 类
----------------------

local M     = classSprite("PropBox")
M.TAG       = "PropBox"

----------------------
-- 公共参数
----------------------
local Config = require("app.biathlon.Config")
-- 加速带可以多提供的额外速度
local addMaxSpeed   = Config.speedNodeMaxSpeed
----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]

function M:ctor(params)
    -- [超类调用]
    M.super.ctor(self, params)


    self._highLimit = 15
end

----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]

function M:onRender()
    -- [超类调用]
    M.super.onRender(self)

    -- 图片渲染
    self:loadDisplay()
end

------------------------------------------------------------------------------------------------
-- 功能函数
------------------------------------------------------------------------------------------------
-- -- 图片渲染
function M:loadDisplay()
    -- 亮起时的节点
    local lightNode = D.img("biathlon/speedline/2.png"):p(self:cw()/2, self:ch()/2):to(self, 50):opacity(0)
    self._lightNode = lightNode
end

-- -- 被碰撞事件
function M:beCrashEvent(role)
    local vec = role._body:GetLinearVelocity()
    if vec.x > 0 then
        if not self._sndCold and role._isPlayer then
            self._sndCold = true
            -- 播放音效[sfx26233006]经过加速箭头
            soundEffect:playEffectsfx26233006()
            self:plan(function()
                self._sndCold = false
            end, 1)
        end
        -- 加速
        local addX = addMaxSpeed
        local speedExtSpeed = role._speedNodeExSpeed + addX
        speedExtSpeed       = speedExtSpeed <= addMaxSpeed and speedExtSpeed or addMaxSpeed
        role._speedNodeExSpeed   = speedExtSpeed -- 放在tick里减
        role:applySkiSpeed(50)
        
        if self._lightNode:opacity() == 0 then
            A.line({
                {"fadeIn", 0.1},
                {"delay", 0.2},
                {"fadeTo", 0.2, 0},
            }):at(self._lightNode)
        end
    end
end



----------------------
-- 结点析构
----------------------

function M:onDestructor()
    -- [超类调用]
    M.super.onDestructor(self)
end

----------------------
-- 过度动画开始之前的调用
----------------------
--[[--

1.资源释放，退出场景前的操作准备
2.处理视图结点卸载、事件解除绑定等相关操作

]]

function M:onExitTransitionStart()

end

----------------------
-- 验证
----------------------

-- 验证合法性[构造函数参数]
function M:assertParameters(params)
    
end

return M
